## mingw-w64-itk-5.4.0-1.src.tar.zst

=== Modules/Core/Common/CMakeLists.txt ===
project(ITKCommon)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake ${CMAKE_MODULE_PATH})

# Version string should not include patch level.  The major.minor is
# enough to distinguish available features of the toolkit.
set(ITK_VERSION_STRING "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}")

include(TestBigEndian)
test_big_endian(CMAKE_WORDS_BIGENDIAN)

include(FindThreads)
set(ITK_USE_WIN32_THREADS 0)
set(ITK_USE_PTHREADS 0)
set(ITK_HP_PTHREADS 0)
if(CMAKE_USE_WIN32_THREADS_INIT)
  set(ITK_USE_WIN32_THREADS 1)
elseif(CMAKE_USE_PTHREADS_INIT AND NOT EMSCRIPTEN)
  set(ITK_USE_PTHREADS 1)
elseif(CMAKE_HP_PTHREADS_INIT)
  set(ITK_HP_PTHREADS 1)
endif()
set(CMAKE_THREAD_LIBS
    "${CMAKE_THREAD_LIBS_INIT}"
    CACHE STRING "Thread library used.")
mark_as_advanced(CMAKE_THREAD_LIBS)
set(ITK_DEFAULT_MAX_THREADS
    128
    CACHE STRING "The maximum number of threads allowed. Default: 128")
mark_as_advanced(ITK_DEFAULT_MAX_THREADS)

set(ITK_DEFAULT_THREADER
    "Auto"
    CACHE STRING "Default multithreader.")
mark_as_advanced(ITK_DEFAULT_THREADER)
set_property(
  CACHE ITK_DEFAULT_THREADER
  PROPERTY STRINGS
           Auto
           TBB
           Pool
           Platform)

# See if compiler preprocessor has the __FUNCTION__ directive used by itkExceptionMacro
include(CheckCPPDirective)
check_cpp_directive_exists(__FUNCTION__ ITK_CPP_FUNCTION)

include(CheckIncludeFiles)

# check if the platform has the header file "fenv.h" which has been added as part of the C99 standard
check_include_files(fenv.h HAVE_FENV_H)
# check if the platform has some widely used header files
check_include_files("unistd.h" HAVE_UNISTD_H)

if(CMAKE_CXX_STANDARD)
  set(TRY_COMP_CXX_STANDARD -DCMAKE_CXX_STANDARD:STRING=${CMAKE_CXX_STANDARD})
endif()
# Identify the version of CXX compiler used when ITK was built. This needs to be
# identified so that external applications can identify how ITK was built.
set(ITK_COMPILED_CXX_STANDARD_VERSION 1)
foreach(CXX_TEST_VERSION 201103L 201402L 201703L)
  try_compile(
    ITK_MIN_CXX_LEVEL_TEST ${CMAKE_CURRENT_BINARY_DIR}/CMakeTmp
    ${CMAKE_CURRENT_LIST_DIR}/CMake/itkGetCXXCompilerVersion.cxx
    CMAKE_FLAGS ${TRY_COMP_CXX_STANDARD}
    COMPILE_DEFINITIONS -DITK_CXX_TEST_VERSION=${CXX_TEST_VERSION}
    OUTPUT_VARIABLE ITK_COMPILED_CXX_STANDARD_VERSION_LOG)
  if(ITK_MIN_CXX_LEVEL_TEST)
    set(ITK_COMPILED_CXX_STANDARD_VERSION ${CXX_TEST_VERSION})
  endif()
endforeach()

try_compile(
  ITK_HAS_GNU_ATTRIBUTE_ALIGNED ${ITK_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasGNUAttributeAligned.cxx
  CMAKE_FLAGS "-DCMAKE_BUILD_TYPE:STRING=Debug")

set(ITK_WINDOWS_EXPORT_ALL_SYMBOLS ${CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS})

try_compile(ITK_HAS_MALLINFO ${ITK_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasMallinfo.cxx)

try_compile(ITK_HAS_MALLINFO2 ${ITK_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasMallinfo2.cxx)

try_compile(ITK_HAS_FEENABLEEXCEPT ${ITK_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasFeenableexcept.cxx)

try_compile(ITK_HAS_FEGETENV ${ITK_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasFegetenv.cxx)

try_compile(ITK_HAS_FESETENV ${ITK_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasFesetenv.cxx)

try_compile(
  ITK_HAS_STRUCT_FENV_T_CONTROL ${ITK_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasFenvtStructMember.cxx
  COMPILE_DEFINITIONS -DITK_CHECK_FENV_T_CONTROL)

try_compile(
  ITK_HAS_STRUCT_FENV_T_CONTROL_WORD ${ITK_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasFenvtStructMember.cxx
  COMPILE_DEFINITIONS -DITK_CHECK_FENV_T_CONTROL_WORD)

try_compile(
  ITK_HAS_STRUCT_FENV_T_CW ${ITK_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/itkCheckHasFenvtStructMember.cxx
  COMPILE_DEFINITIONS -DITK_CHECK_FENV_T_CW)

#-----------------------------------------------------------------------------
# Make default visibility as an option for generated export header

# check if private (hidden, local) symbols can be dynamic_cast between
# different instances.
include(itkCheckPrivateDynamicCast)

set(_template_visibility_init OFF)
if(NOT ITK_PRIVATE_DYNAMIC_CAST AND NOT (CMAKE_CXX_VISIBILITY_PRESET STREQUAL "hidden" AND NOT BUILD_SHARED_LIBS))
  set(_template_visibility_init ON)
endif()
# This adds default symbol visibility to template class types, which
# results in 'weak external typeinfo' in libraries that use these
# types, whether with implicit or explicit instantiation, default
# hidden or non-hidden visibility.
# This is required on Mac OSX to avoid dynamic_cast failures across binaries.
# See Change-Id: Ib4a6b8cafe8720c3a2a5b3e6ba833d11002978df for more information."
option(ITK_TEMPLATE_VISIBILITY_DEFAULT
       "Set symbol visibility to default for template class declarations. https://itk.org/Wiki/ITK/FAQ"
       "${_template_visibility_init}")
mark_as_advanced(ITK_TEMPLATE_VISIBILITY_DEFAULT)

# Configuration variable is named ITK_USE_TBB instead of simply using the
# TBB module name (Module_ITKTBB) for code readability.
set(ITK_USE_TBB ${Module_ITKTBB})

configure_file(src/itkConfigure.h.in itkConfigure.h)
configure_file(src/itkConfigurePrivate.h.in itkConfigurePrivate.h)

set(ITKCommon_INCLUDE_DIRS ${ITKCommon_BINARY_DIR})
set(ITKCommon_LIBRARIES ITKCommon)

itk_module_impl()

install(
  FILES ${ITKCommon_BINARY_DIR}/itkConfigure.h
  DESTINATION ${ITKCommon_INSTALL_INCLUDE_DIR}
  COMPONENT Development)

=== Modules/Core/ImageAdaptors/CMakeLists.txt ===
project(ITKImageAdaptors)
itk_module_impl()

=== Modules/Core/TestKernel/CMakeLists.txt ===
project(ITKTestKernel)
set(ITKTestKernel_LIBRARIES ITKTestKernel)
itk_module_impl()

=== Modules/IO/Mesh/CMakeLists.txt ===
project(ITKIOMesh)
itk_module_impl()

=== Modules/Bridge/NumPy/test/CMakeLists.txt ===
itk_module_test()

=== Modules/Core/QuadEdgeMesh/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKQuadEdgeMesh)

set(WRAPPER_SUBMODULE_ORDER
    itkQuadEdge
    itkGeometricalQuadEdge
    itkQuadEdgeMeshPoint
    itkQuadEdgeMeshTraits
    itkQuadEdgeCellTraitsInfo
    itkQuadEdgeMeshLineCell
    itkQuadEdgeMeshBase
    # itkQuadEdgeMesh
    itkQuadEdgeMeshToQuadEdgeMeshFilter)
itk_auto_load_and_end_wrap_submodules()

=== Modules/Filtering/GPUThresholding/test/CMakeLists.txt ===
if(ITK_USE_GPU)

  itk_module_test()

  set(ITKGPUThresholding-tests
      itkGPUImageFilterTest.cxx
      #itkGPUImageFilterTestTemp.cxx
      itkGPUBinaryThresholdImageFilterTest.cxx)

  createtestdriver(ITKGPUThresholding "${ITKGPUThresholding-Test_LIBRARIES}" "${ITKGPUThresholding-tests}")

  itk_add_test(
    NAME
    itkGPUImageFilterTest2D
    COMMAND
    ITKGPUThresholdingTestDriver
    itkGPUImageFilterTest
    ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
    ${ITK_TEST_OUTPUT_DIR}/gpuImageFilterTest2D.png
    2)
  itk_add_test(
    NAME
    itkGPUImageFilterTest3D
    COMMAND
    ITKGPUThresholdingTestDriver
    itkGPUImageFilterTest
    ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
    ${ITK_TEST_OUTPUT_DIR}/gpuImageFilterTest3D.png
    3)

  #
  #temporary test
  #itk_add_test(NAME itkGPUImageFilterTestTemp
  #        COMMAND ITKGPUThresholdingTestDriver itkGPUImageFilterTestTemp
  #        ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
  #        ${ITK_TEST_OUTPUT_DIR}/gpuImageFilterTest.png)

  itk_add_test(
    NAME
    itkGPUBinaryThresholdImageFilterTest2D
    COMMAND
    ITKGPUThresholdingTestDriver
    itkGPUBinaryThresholdImageFilterTest
    ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
    ${ITK_TEST_OUTPUT_DIR}/gpuBinaryThresholdImageFilterTest2D.mha
    2)

  itk_add_test(
    NAME
    itkGPUBinaryThresholdImageFilterTest3D
    COMMAND
    ITKGPUThresholdingTestDriver
    itkGPUBinaryThresholdImageFilterTest
    ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySlice.png
    ${ITK_TEST_OUTPUT_DIR}/gpuBinaryThresholdImageFilterTest3D.mha
    3)

endif()

=== Modules/Filtering/ImageSources/test/CMakeLists.txt ===
itk_module_test()
set(ITKImageSourcesTests
    itkGaborKernelFunctionTest.cxx
    itkGaborImageSourceTest.cxx
    itkGaussianImageSourceTest.cxx
    itkGridImageSourceTest.cxx
    itkPhysicalPointImageSourceTest.cxx)

createtestdriver(ITKImageSources "${ITKImageSources-Test_LIBRARIES}" "${ITKImageSourcesTests}")

itk_add_test(
  NAME
  itkGaborKernelFunctionTest
  COMMAND
  ITKImageSourcesTestDriver
  itkGaborKernelFunctionTest)
itk_add_test(
  NAME
  itkGaborImageSourceTest0
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/GaborImageSourceTest0.mha}
  ${ITK_TEST_OUTPUT_DIR}/GaborImageSourceTest0.mha
  itkGaborImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/GaborImageSourceTest0.mha
  0)
itk_add_test(
  NAME
  itkGaborImageSourceTest1
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/GaborImageSourceTest1.mha}
  ${ITK_TEST_OUTPUT_DIR}/GaborImageSourceTest1.mha
  itkGaborImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/GaborImageSourceTest1.mha
  1)
itk_add_test(
  NAME
  itkGaussianImageSourceTest1
  COMMAND
  ITKImageSourcesTestDriver
  --compare-MD5
  ${ITK_TEST_OUTPUT_DIR}/itkGaussianImageSourceTest1.nrrd
  551a41aa2478ba271e3e1820ddffa03d
  itkGaussianImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkGaussianImageSourceTest1.nrrd
  0)
itk_add_test(
  NAME
  itkGaussianImageSourceTest2
  COMMAND
  ITKImageSourcesTestDriver
  --compare-MD5
  ${ITK_TEST_OUTPUT_DIR}/itkGaussianImageSourceTest2.nrrd
  5bf79f0539922f9c654dafd2601330b1
  itkGaussianImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkGaussianImageSourceTest2.nrrd
  1)
itk_add_test(
  NAME
  itkGridImageSourceTest1
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkGridImageSourceTest1.nhdr,itkGridImageSourceTest1.raw.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest1.nhdr
  itkGridImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest1.nhdr
  64
  3
  0
  8.0
  0
  0.0
  1
  0
  1
  0)
itk_add_test(
  NAME
  itkGridImageSourceTest2
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkGridImageSourceTest2.nhdr,itkGridImageSourceTest2.raw.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest2.nhdr
  itkGridImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest2.nhdr
  64
  3
  0
  16.0
  0
  0.0
  1
  0
  1
  3)
itk_add_test(
  NAME
  itkGridImageSourceTest3
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkGridImageSourceTest3.nhdr,itkGridImageSourceTest3.raw.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest3.nhdr
  itkGridImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest3.nhdr
  32
  3
  0
  4.0
  0
  0.0
  1
  1
  0
  0)
itk_add_test(
  NAME
  itkGridImageSourceTest4
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkGridImageSourceTest4.nhdr,itkGridImageSourceTest4.raw.gz}
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest4.nhdr
  itkGridImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkGridImageSourceTest4.nhdr
  64
  1.0
  1
  32.0
  1
  0.0
  1
  0
  0
  0)
itk_add_test(
  NAME
  itkPhysicalPointImageSourceTest0
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkPhysicalPointImageSourceTest0.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest0.mha
  itkPhysicalPointImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest0.mha
  0)
itk_add_test(
  NAME
  itkPhysicalPointImageSourceTest1
  COMMAND
  ITKImageSourcesTestDriver
  # this should be the same baseline as test 0
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkPhysicalPointImageSourceTest0.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest1.mha
  itkPhysicalPointImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest1.mha
  1)
itk_add_test(
  NAME
  itkPhysicalPointImageSourceTest2
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkPhysicalPointImageSourceTest2.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest2.mha
  itkPhysicalPointImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest2.mha
  2)
itk_add_test(
  NAME
  itkPhysicalPointImageSourceTest3
  COMMAND
  ITKImageSourcesTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkPhysicalPointImageSourceTest0.mha}
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest3.mha
  itkPhysicalPointImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest3.mha
  3
  0.0)
itk_add_test(
  NAME
  itkPhysicalPointImageSourceTest4
  COMMAND
  ITKImageSourcesTestDriver
  --compareIntensityTolerance
  .0001
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/Filtering/itkPhysicalPointImageSourceTest4.nrrd}
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest4.nrrd
  itkPhysicalPointImageSourceTest
  ${ITK_TEST_OUTPUT_DIR}/itkPhysicalPointImageSourceTest4.nrrd
  3
  0.785398163)

=== Modules/IO/MINC/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOMINC)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/MRC/src/CMakeLists.txt ===
set(ITKIOMRC_SRCS itkMRCHeaderObject.cxx itkMRCImageIO.cxx itkMRCImageIOFactory.cxx)

itk_module_add_library(ITKIOMRC ${ITKIOMRC_SRCS})

=== Modules/IO/Mesh/test/CMakeLists.txt ===
itk_module_test()

set(ITKIOMeshTests itkMeshFileReadWriteTest.cxx)

createtestdriver(ITKIOMesh "${ITKIOMesh-Test_LIBRARIES}" "${ITKIOMeshTests}")

itk_add_test(
  NAME
  itkMeshFileReadWriteTest01
  COMMAND
  ITKIOMeshTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/sphere.fsb}
  ${ITK_TEST_OUTPUT_DIR}/sphere01.vtk)
itk_add_test(
  NAME
  itkMeshFileReadWriteTest03
  COMMAND
  ITKIOMeshTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/sphere_curv.vtk}
  ${ITK_TEST_OUTPUT_DIR}/sphere_curv_03.vtk)
itk_add_test(
  NAME
  itkMeshFileReadWriteTest04
  COMMAND
  ITKIOMeshTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/thickness.fcv}
  ${ITK_TEST_OUTPUT_DIR}/thickness.fcv)
itk_add_test(
  NAME
  itkMeshFileReadWriteTest07
  COMMAND
  ITKIOMeshTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/sphere_curv_b.vtk}
  ${ITK_TEST_OUTPUT_DIR}/sphere_curv_07.vtk
  1)

=== Modules/IO/Meta/test/CMakeLists.txt ===
itk_module_test()
set(ITKIOMetaTests
    itkMetaImageIOMetaDataTest.cxx
    itkMetaImageIOGzTest.cxx
    itkMetaImageIOTest.cxx
    itkMetaImageIOTest2.cxx
    itkLargeMetaImageWriteReadTest.cxx
    testMetaArray.cxx
    testMetaCommand.cxx
    testMetaGroup.cxx
    testMetaImage.cxx
    testMetaMesh.cxx
    itkMetaImageStreamingIOTest.cxx
    itkMetaImageStreamingWriterIOTest.cxx
    itkMetaTestLongFilename.cxx)

createtestdriver(ITKIOMeta "${ITKIOMeta-Test_LIBRARIES}" "${ITKIOMetaTests}")

itk_add_test(
  NAME
  itkMetaImageIOMetaDataTest
  COMMAND
  ITKIOMetaTestDriver
  itkMetaImageIOMetaDataTest
  ${ITK_TEST_OUTPUT_DIR}/MetaImageIOMetaDataTest.mhd)
itk_add_test(
  NAME
  itkMetaImageIOGzTest
  COMMAND
  ITKIOMetaTestDriver
  itkMetaImageIOGzTest
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkMetaImageIOTest
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolume.mhd
  itkMetaImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolume.mhd)
itk_add_test(
  NAME
  itkMetaImageIOTestList
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/SmallRampVolume.mhd,SmallRampVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestList.mhd
  itkMetaImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/MetaIO/SmallRampVolumeList.mhd,SmallRampVolume01.tif,SmallRampVolume02.tif,SmallRampVolume03.tif,SmallRampVolume04.tif,SmallRampVolume05.tif,SmallRampVolume06.tif}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestList.mhd)
itk_add_test(
  NAME
  itkMetaImageIOTestListWithFilenameSpaces
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/SmallRampVolume.mhd,SmallRampVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestListWithFilenameSpaces.mhd
  itkMetaImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/MetaIO/Small\ Ramp\ Volume\ List.mhd,Small\ Ramp\ Volume\ 01.tif,Small\ Ramp\ Volume\ 02.tif,Small\ Ramp\ Volume\ 03.tif,Small\ Ramp\ Volume\ 04.tif,Small\ Ramp\ Volume\ 05.tif,Small\ Ramp\ Volume\ 06.tif}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestListWithFilenameSpaces.mhd)
itk_add_test(
  NAME
  itkMetaImageIOTestRegEx
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/SmallRampVolume.mhd,SmallRampVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestRegEx.mhd
  itkMetaImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/MetaIO/SmallRampVolumeRegEx.mhd,SmallRampVolume01.tif,SmallRampVolume02.tif,SmallRampVolume03.tif,SmallRampVolume04.tif,SmallRampVolume05.tif,SmallRampVolume06.tif}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestRegEx.mhd)
itk_add_test(
  NAME
  itkMetaImageIOTestRegExWithFilenameSpaces
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/SmallRampVolume.mhd,SmallRampVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestRegExWithFilenameSpaces.mhd
  itkMetaImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/MetaIO/Small\ Ramp\ Volume\ Reg\ Ex.mhd,Small\ Ramp\ Volume\ 01.tif,Small\ Ramp\ Volume\ 02.tif,Small\ Ramp\ Volume\ 03.tif,Small\ Ramp\ Volume\ 04.tif,Small\ Ramp\ Volume\ 05.tif,Small\ Ramp\ Volume\ 06.tif}
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTestRegExWithFilenameSpaces.mhd)
itk_add_test(
  NAME
  itkMetaImageIOTest2
  COMMAND
  ITKIOMetaTestDriver
  itkMetaImageIOTest2
  ${ITK_TEST_OUTPUT_DIR}/itkMetaImageIOTest2.mha)
itk_add_test(
  NAME
  itkMetaImageIOShouldFailTest
  COMMAND
  ITKIOMetaTestDriver
  itkMetaImageIOTest
  DATA{${ITK_DATA_ROOT}/Input/MetaImageError.mhd}
  "OutputNotUsed"
  1)
itk_add_test(
  NAME
  testMetaGroup
  COMMAND
  ITKIOMetaTestDriver
  testMetaGroup
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  testMetaImage
  COMMAND
  ITKIOMetaTestDriver
  testMetaImage)
itk_add_test(
  NAME
  testMetaMesh
  COMMAND
  ITKIOMetaTestDriver
  testMetaMesh
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  MetaCommandRequiredOptionsWithMultipleStrings
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  7
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7)
itk_add_test(
  NAME
  MetaCommandRequiredOptionsWithMultipleStringsAtEnd
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  7
  -r2_ri
  7
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3)
itk_add_test(
  NAME
  MetaCommandOptionalWithRequired
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  107
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o1_ri
  1
  -o2_ri
  99)
itk_add_test(
  NAME
  MetaCommandOptionalOptoinsWithOutArguments
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  207
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o1_oi
  -o2_oi)
itk_add_test(
  NAME
  MetaCommandOptionalOptoinsWithOutArguments1
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  107
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o1_oi
  1
  -o2_oi
  99)
itk_add_test(
  NAME
  MetaCommandRequiredAndOptionalOptoinsWithArguments
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  207
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o1_ri
  1
  -o2_ri
  99
  -o3_ri_oi
  50
  50)
itk_add_test(
  NAME
  MetaCommandRequiredAndOptionalOptoinsWithOutArguments
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  257
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o1_ri
  1
  -o2_ri
  99
  -o3_ri_oi
  50)
itk_add_test(
  NAME
  MetaCommandRequiredAndOptionalOptoinsWithOutArguments-1
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  0
  -sum
  457
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o1_ri
  1
  -o2_ri
  99
  -o3_ri_oi
  50
  -o1_oi
  -o2_oi)
itk_add_test(
  NAME
  MetaCommandRequiredOptionsWithMissingMultipleStrings
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  1
  -sum
  7
  -r1c_rs
  -r2_ri
  7)
itk_add_test(
  NAME
  MetaCommandRequiredOptionsWithMissingMultipleStringsAtEnd
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  1
  -sum
  7
  -r2_ri
  7
  -r1c_rs)
itk_add_test(
  NAME
  MetaCommandOptionalWithRequiredMissing
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  1
  -sum
  107
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  -o1_ri
  1
  -o2_ri
  99)
itk_add_test(
  NAME
  MetaCommandRequiredAndOptionalOptoinsWithArgumentsMissing
  COMMAND
  ITKIOMetaTestDriver
  testMetaCommand
  -ExpectedFailStatus
  1
  -sum
  207
  -r1c_rs
  StringValue1
  StringValue2
  StringValue3
  -r2_ri
  7
  -o3_ri_oi)
itk_add_test(
  NAME
  testMetaArray
  COMMAND
  ITKIOMetaTestDriver
  testMetaArray
  ${ITK_TEST_OUTPUT_DIR})
itk_add_test(
  NAME
  itkMetaImageStreamingIOTest
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolumeStreamed.mhd
  itkMetaImageStreamingIOTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolumeStreamed.mhd)
itk_add_test(
  NAME
  itkMetaImageCompressedStreamingIOTest
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolumeCompressedStreamed.mha
  itkMetaImageStreamingIOTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolumeCompressed.mha}
  ${ITK_TEST_OUTPUT_DIR}/HeadMRVolumeCompressedStreamed.mha)
itk_add_test(
  NAME
  itkMetaImageStreamingWriterIOTest
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Baseline/IO/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/MetaImageStreamingWriterIOTest.mha
  itkMetaImageStreamingWriterIOTest
  DATA{${ITK_DATA_ROOT}/Input/HeadMRVolume.mhd,HeadMRVolume.raw}
  ${ITK_TEST_OUTPUT_DIR}/MetaImageStreamingWriterIOTest.mha)

# The data contained in ${ITK_DATA_ROOT}/Input/DicomSeries/
# is required by mri3D.mhd:
# ElementDataFile = DicomSeries/Image%04d.dcm 75 77 1
# The data file and its associated files are in different
# directories, respectively ${ITK_DATA_ROOT}/Input/ and
# ${ITK_DATA_ROOT}/Input/DicomSeries/
# Since DATA{} does not allow to specify an associated
# file that is in a different directory, we call ExternalData_Expand_Arguments
# manually to download the required files.
ExternalData_expand_arguments(ITKData ExpandedData DATA{${ITK_DATA_ROOT}/Input/DicomSeries/,REGEX:Image[0-9]+.dcm})

itk_add_test(
  NAME
  itkMetaImageStreamingWriterIOTest2
  COMMAND
  ITKIOMetaTestDriver
  --compare
  DATA{${ITK_DATA_ROOT}/Input/mri3D.mhd}
  ${ITK_TEST_OUTPUT_DIR}/mri3DWriteStreamed.mha
  itkMetaImageStreamingWriterIOTest
  DATA{${ITK_DATA_ROOT}/Input/mri3D.mhd}
  ${ITK_TEST_OUTPUT_DIR}/mri3DWriteStreamed.mha)

itk_add_test(
  NAME
  itkMetaTestLongFilename
  COMMAND
  ITKIOMetaTestDriver
  itkMetaTestLongFilename)

if("${ITK_COMPUTER_MEMORY_SIZE}" GREATER 5)

  # Image of 1.67 Gigabytes (pixels size is 16bits)
  itk_add_test(
    NAME
    itkLargeMetaImageWriteReadTest1
    COMMAND
    ITKIOMetaTestDriver
    itkLargeMetaImageWriteReadTest
    ${ITK_TEST_OUTPUT_DIR}/LargeImage01.mhd
    30000L)

  # Image of 2.98 Gigabytes (pixels size is 16bits)
  itk_add_test(
    NAME
    itkLargeMetaImageWriteReadTest2
    COMMAND
    ITKIOMetaTestDriver
    itkLargeMetaImageWriteReadTest
    ${ITK_TEST_OUTPUT_DIR}/LargeImage02.mhd
    40000L)

  # Image of 4.9 Gigabytes (pixels size is 8-bits out and 16-bit in)
  itk_add_test(
    NAME
    itkLargeMetaImageWriteReadTest3
    COMMAND
    ITKIOMetaTestDriver
    itkLargeMetaImageWriteReadTest
    ${ITK_TEST_OUTPUT_DIR}/LargeImage03.mhd
    50000L)

  # Due to the large memory requirements this tests must be run one by one
  set_tests_properties(
    itkLargeMetaImageWriteReadTest1 itkLargeMetaImageWriteReadTest2 itkLargeMetaImageWriteReadTest3
    PROPERTIES LABELS
               BigIO
               RESOURCE_LOCK
               MEMORY_SIZE
               COST
               10)
  set_property(
    TEST itkLargeMetaImageWriteReadTest1
    APPEND
    PROPERTY LABELS RUNS_LONG)
  set_property(
    TEST itkLargeMetaImageWriteReadTest2
    APPEND
    PROPERTY LABELS RUNS_LONG)
  set_property(
    TEST itkLargeMetaImageWriteReadTest3
    APPEND
    PROPERTY LABELS RUNS_LONG)
endif()

if("${ITK_COMPUTER_MEMORY_SIZE}" GREATER 12)

  # Image of 9.12 Gigabytes (pixels size is 16bits)
  itk_add_test(
    NAME
    itkLargeMetaImageWriteReadTest4
    COMMAND
    ITKIOMetaTestDriver
    itkLargeMetaImageWriteReadTest
    ${ITK_TEST_OUTPUT_DIR}/LargeImage04.mhd
    70000L)

  # Due to the large memory requirements this tests must be run one by one
  set_tests_properties(
    itkLargeMetaImageWriteReadTest4
    PROPERTIES LABELS
               BigIO
               RESOURCE_LOCK
               MEMORY_SIZE
               COST
               30)
  set_property(
    TEST itkLargeMetaImageWriteReadTest4
    APPEND
    PROPERTY LABELS RUNS_LONG)
  set_property(
    TEST itkLargeMetaImageWriteReadTest4
    APPEND
    PROPERTY RUN_SERIAL True)

endif()

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>

_realname=itk
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.4.0
pkgrel=1
pkgdesc='An open-source C++ toolkit for medical image processing (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://www.itk.org/'
msys2_repository_url="https://github.com/InsightSoftwareConsortium/ITK"
msys2_references=(
  'aur: itk'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-dcmtk"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gdcm"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-opencv"
             "${MINGW_PACKAGE_PREFIX}-vtk"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-opencv: ITK-OpenCV bridge"
            "${MINGW_PACKAGE_PREFIX}-vtk: ITK-VTK bridge")
source=("https://github.com/InsightSoftwareConsortium/ITK/archive/v${pkgver}/ITK-${pkgver}.tar.gz")
sha256sums=('d71a36fc0aee2c9257fe128f7657feb1e671461bd48561b620619f290c71795e')

prepare() {
  cd "${srcdir}"/ITK-${pkgver}
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DITK_INSTALL_INCLUDE_DIR=include/ITK \
    -DITK_INSTALL_DATA_DIR=share/ITK \
    -DITK_INSTALL_DOC_DIR=share/doc/ITK \
    -DITK_INSTALL_PACKAGE_DIR=lib/cmake/ITK \
    -DITK_CUSTOM_LIBRARY_SUFFIX="" \
    -DITK_LEGACY_REMOVE=ON \
    -DITK_FUTURE_LEGACY_REMOVE=ON \
    -DITK_BUILD_DEFAULT_MODULES=OFF \
    -DITKGroup_Core=ON \
    -DITKGroup_IO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \
    -DITKGroup_Filtering=ON \
    -DITKGroup_Registration=ON \
    -DITKGroup_Segmentation=ON \
    -DITKGroup_Numerics=ON \
    -DITKGroup_Video=ON \
    -DITKGroup_ThirdParty=ON \
    -DITKGroup_Bridge=ON \
    -DITKGroup_Nonunit=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \ \
    -DITKGroup_Compatibility=ON \
    -DModule_ITKVideoBridgeOpenCV=ON \
    -DModule_ITKVtkGlue=ON \
    -DITK_USE_GPU=OFF \
    -DUSE_FFTWD=ON \
    -DUSE_FFTWF=ON \
    -DITK_USE_SYSTEM_LIBRARIES=ON \
    -DITK_USE_SYSTEM_DCMTK=ON \
    -DITK_USE_SYSTEM_DOUBLECONVERSION=ON \
    -DITK_USE_SYSTEM_EIGEN=ON \
    -DITK_USE_SYSTEM_EXPAT=ON \
    -DITK_USE_SYSTEM_FFTW=ON \
    -DITK_USE_SYSTEM_GDCM=ON \
    -DITK_USE_SYSTEM_GOOGLETEST=ON \
    -DITK_USE_SYSTEM_HDF5=ON \
    -DITK_USE_SYSTEM_JPEG=ON \
    -DITK_USE_SYSTEM_MINC=OFF \
    -DITK_USE_SYSTEM_PNG=ON \
    -DITK_USE_SYSTEM_TIFF=ON \
    -DITK_USE_SYSTEM_VXL=OFF \
    -DITK_USE_SYSTEM_ZLIB=ON \
    -DITK_SKIP_PATH_LENGTH_CHECKS=1 \
    -DITK_FORBID_DOWNLOADS=ON \
    -DVNL_CONFIG_THREAD_SAFE=ON \
    -DVNL_CONFIG_ENABLE_SSE2_ROUNDING=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    "${_extra_config[@]}" \
    "../ITK-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  cd "${pkgdir}${MINGW_PREFIX}"
  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|\${_IMPORT_PREFIX}|g" \
    -i "lib/cmake/${_realname}/ITKTargets-release.cmake"
  find "lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_DEPS}|\${ITK_INSTALL_PREFIX}|g" -i {} \;

  install -Dm644 "${srcdir}/ITK-${pkgver}/LICENSE" "share/licenses/${_realname}/LICENSE"
  install -Dm644 "${srcdir}/ITK-${pkgver}/NOTICE" "share/licenses/${_realname}/NOTICE"
  install -Dm644 "${srcdir}/ITK-${pkgver}/Modules/ThirdParty/KWSys/src/KWSys/Copyright.txt" \
    "share/licenses/${_realname}/KWSys/Copyright.txt"
}
